#include <iostream>
#include <vector>
#include "square.hpp"
#include "rectangle.hpp"
#include "triangle.hpp"
#include "hexagon.hpp"

using namespace std;

int main()
{
    vector<Shape*> shapes; // alakzat mutatk vektora

    shapes.push_back(new Square(2));
    shapes.push_back(new Rectangle(2, 4));
    shapes.push_back(new Triangle(2));
    shapes.push_back(new Hexagon(2));

    for (int i = 0; i < shapes.size(); i++)
    {
        // tpuskonverzi segtsgvel hatrozzuk meg a leszrmazott tpust
        if (dynamic_cast<Square*>(shapes[i]))
            cout << "square, ";
        if (dynamic_cast<Rectangle*>(shapes[i]))
            cout << "rectangle, ";
        if (dynamic_cast<Triangle*>(shapes[i]))
            cout << "triangle, ";
        if (dynamic_cast<Hexagon*>(shapes[i]))
            cout << "hexagon, ";

        cout << "area: " << shapes[i]->Area() << ", perimeter: " << shapes[i]->Perimeter() << endl;

    }

    return 0;
}
